import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class GUIDemo implements Runnable, ActionListener {
	private JLabel label;
	private JButton button, button2;
	private JCheckBox checkBox;
	private JRadioButton radio1, radio2, radio3;
	private JTextField textField;
	private JLabel revTextLabel;

	private int count = 0;

	private class ButtonActionListener implements ActionListener {

		@Override
		public void actionPerformed(ActionEvent e) {
			int inc = 1;
			if (radio2.isSelected()) {
				inc = 2;
			} else if (radio3.isSelected()) {
				inc = 3;
			}
			  if (checkBox.isSelected()) {
			    count -= inc;
			  } else {
				  count += inc;
			  }
			  label.setText(Integer.toString(count));
		}

	}

	private class Button2ActionListener implements ActionListener {

		@Override
		public void actionPerformed(ActionEvent e) {
		  count = 0;
		  label.setText(Integer.toString(count));
		}
	}

	private class TextFieldActionListener implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			revTextLabel.setText(textField.getText().toUpperCase());
		}

	}

	@Override
    public void run() {
        JFrame frame = new JFrame("GUIStart");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

//        frame.setLayout(new BoxLayout(frame.getContentPane(), BoxLayout.X_AXIS));
        frame.setLayout(new FlowLayout());

        label = new JLabel("Counter");
        frame.add(label);

        button = new JButton("Count");
//        frame.getContentPane().add(button, BorderLayout.SOUTH);
        frame.add(button);

        button2 = new JButton("Reset");
//      frame.getContentPane().add(button2, BorderLayout.SOUTH);
      	frame.add(button2);

        JPanel panel = new JPanel();
        frame.getContentPane().add(panel);
        panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));

        JLabel label2 = new JLabel("Step");
        panel.add(label2);

//        JLabel label3 = new JLabel("JLabel3");
//        panel.add(label3);

        checkBox = new JCheckBox("Count down");
        frame.add(checkBox);

        radio1 = new JRadioButton("1");
        radio2 = new JRadioButton("2");
        radio3 = new JRadioButton("3");

        ButtonGroup buttonGroup = new ButtonGroup();
        buttonGroup.add(radio1);
        radio1.setSelected(true);
        buttonGroup.add(radio2);
        buttonGroup.add(radio3);

        panel.add(radio1);
        panel.add(radio2);
        panel.add(radio3);

        JPanel panel2 = new JPanel();
        panel2.setLayout(new BoxLayout(panel2, BoxLayout.Y_AXIS));
        frame.add(panel2);

        textField = new JTextField(10);
        panel2.add(textField);

        revTextLabel = new JLabel();
        panel2.add(revTextLabel);

        frame.pack();
        frame.setVisible(true);

        //button.addActionListener(this);
        //button2.addActionListener(this);
        button.addActionListener(new ButtonActionListener());
        button2.addActionListener(new Button2ActionListener());

        textField.addActionListener(new TextFieldActionListener());
    }

	public static void main(String[] args) {
        SwingUtilities.invokeLater(new GUIDemo());
	}
// We can make a class it's own ActionListener. This class implements
// the ActionListener interface, so we can implement a actionPerformed
// method here which checks the source of a button press to distinguish
// which one was pressed.
	@Override
	public void actionPerformed(ActionEvent e) {
	  if (e.getSource() == button) {
		  count++;
		  label.setText(Integer.toString(count));
	  } else if (e.getSource() == button2) {
		  count = 0;
		  label.setText(Integer.toString(count));
	  }
	}

}
