import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.layout.StackPane;
import javafx.stage.Stage;

public class HelloWorldFX extends Application {
    public static void main(String[] args) {
        launch(args);
    }

    @Override
    public void start(Stage primaryStage) {
        primaryStage.setTitle("Hello World!");
        Button btn = new Button();
        btn.setText("Say 'Hello World'");
        // Här använder vi en s.k. anonym klass. Vi ska bara använda den
        // en gång, så vi struntar i att ge den ett namn.
        // Notera att EventHandler<T> är en interface-typ. Det är tillåtet
        // att använda interface-typer med new när vi skapar anonyma klasser,
        // eftersom den anonyma klassen inte har något namn.
        /*btn.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {
                System.out.println("Hello World!");
            }
        });*/
        // Alt. använd ett lambda expression (funktion utan namn)
        // I API:et kan vi se att EventHandler är ett s.k. "funktionellt interface".
        // Det betyder att vi kan använda det i lambda-uttryck.
        btn.setOnAction(actionEvent -> {
           System.out.println("Hello World! (using lambda expression)");
         });

        StackPane root = new StackPane();
        //root har en "lista" av komponenter som ska visas (getChildren).
        // vi lägger till "btn" till den listan.
        root.getChildren().add(btn);
        primaryStage.setScene(new Scene(root, 300, 250));
        primaryStage.show();
    }
}
