import java.awt.*;
import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

public class OlympicRingViewer implements Runnable {

    public static void main(String[] args) {
        SwingUtilities.invokeLater(new OlympicRingViewer());
    }

    // Gömmer eller visar comp när man klickar med musen.
    // Notera att vi implementerar lyssnaren som en
    // subklass till MouseAdapter istället för som tidigare
    // implementerande ett interface.
    private class MyMouseListener extends MouseAdapter {
        private JComponent comp;

        public MyMouseListener(JComponent comp) {
            this.comp = comp;
        }

        @Override
        public void mouseClicked(MouseEvent e) {
            comp.setVisible(!comp.isShowing());
        }
    }

    public void run(){
        JFrame frame = new JFrame();

        frame.setPreferredSize(new Dimension (250,200));
        frame.setTitle("Olympic Rings");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        OlympicRingComponent rings = new OlympicRingComponent();
        frame.add(rings, BorderLayout.CENTER);
        JLabel label = new JLabel("Next Olympics: Pyeongchang 2018");
        frame.add(label, BorderLayout.SOUTH);

        frame.addMouseListener(new MyMouseListener(rings));
        frame.pack();

        frame.setVisible(true);
    }

}
