import java.awt.*;
import javax.swing.*;
import java.beans.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

public class OlympicRingViewerPropChange implements Runnable {

    public static void main(String[] args) {
        SwingUtilities.invokeLater(new OlympicRingViewerPropChange());
    }

    // Gömmer eller visar comp när man klickar med musen.
    private class MyMouseListener extends MouseAdapter {
        private JComponent comp;

        public MyMouseListener(JComponent comp) {
            this.comp = comp;
        }

        @Override
        public void mouseClicked(MouseEvent e) {
            comp.setVisible(!comp.isShowing());
        }
    }

    public void run(){
        JFrame frame = new JFrame();

        frame.setPreferredSize(new Dimension (250,200));
        frame.setTitle("Olympic Rings");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        OlympicRingComponent rings = new OlympicRingComponent();
        frame.add(rings, BorderLayout.CENTER);
        JLabel label = new JLabel("Next Olympics: Pyeongchang 2018");
        frame.add(label, BorderLayout.SOUTH);

        frame.addMouseListener(new MyMouseListener(rings));

        PropertyChangeListener p = new PropertyChangeListener(){
          public void propertyChange(PropertyChangeEvent e){
            System.out.println("Egenskapen " + e.getPropertyName() +
                               " ändrades från " + e.getOldValue() +
                               " till " + e.getNewValue());
          }
        };
        // Litet exempel, här inte så intressant eftersom det inte
        // händer så mycket med vår grafik.
        frame.addPropertyChangeListener(p);

        frame.pack();

        frame.setVisible(true);
    }

}
